/*
* Distributed Computational System
* Client Plugin API
*
* $Id: client_plugin.h,v 1.3 2001/11/29 07:06:17 kris Exp $
*/

#ifndef _CLIENT_PLUGIN_H
#define _CLIENT_PLUGIN_H

#include "port.h"

/** Data Structures **/

typedef struct _client_chunk_t {
	long len;		/* length of information in data */
	unsigned char *data;	/* chunk data */
} client_chunk_t;

/* results follow the same format */
typedef client_chunk_t client_result_t;

/* function typedefs */
typedef int (*cl_reportresult_f)( int, client_result_t * );
typedef int (*cp_init_f)( int );
typedef int (*cp_getversion_f)( void );
typedef int (*cp_assignproblemchunk_f)( cl_reportresult_f, unsigned char, client_chunk_t * );

/** Function Prototypes **/

/* Functions to be implemented in the plugin */

DLLEXPORT int CP_Init( int plugin_id );
DLLEXPORT int CP_GetVersion( void );
DLLEXPORT int CP_AssignProblemChunk( cl_reportresult_f report, unsigned char type, client_chunk_t *chunk );

/* Functions provided by the client */

int CL_ReportResult( int plugin_id, client_result_t *result );

#endif /* _CLIENT_PLUGIN_H */
